\section{Structure of a Geant4 application}

\begin{frame}
    \frametitle{How to work with Geant4}

    In order to use Geant4, you proceed as you would with any external library. In other words, you simply have to create an empty project using cmake and link the Geant4 library with your code.\linebreak

    Steps:
    \begin{itemize}
        \item Create an empty C++ project.
        \item Initialize Geant4 in main().
        \item Describe the geometry, primary particles, physics and other functionality.
        \item Compile the code
        \item Run Forest!! Run!
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Modular Architecture}

    Geant4 consist of many modules:

    \begin{itemize}
        \item Run: management of the runs.
        \item Event: management of the events.
        \item Tracking: particle tracks in the geometry.
        \item Processes: physics attached to particles.
        \item Particle: elementary and other particles.
        \item Geometry: description of the detector.
        \item Material: all material properties.
        \item Interfaces: communication with the user.
        \item Visualization: graphical representation of the geometry and tracks.
        \item ... and much more.
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Modular Architecture}

    \begin{center}
        \includegraphics[scale=0.25]{resources/structure}
    \end{center}
\end{frame}

\begin{frame}
    \frametitle{Source Structure}

    \begin{center}
        \includegraphics[scale=0.25]{resources/src_structure}
    \end{center}
\end{frame}

\begin{frame}
    \frametitle{How to add a new class}

    \begin{enumerate}
        \item Select a class to inherit from (if there is one).
        \item Find a good name for your class (Don't be the guy that calls it "MyAwesomeClass", really - don't be that guy.).
        \item Create a header file inside the include folder (include/)
            \begin{itemize}
                \item name it using the class name with a .hh extension.
                \item define the class (inheriting from the base classes, if any).
                \item declare methods to override and other methods.
            \end{itemize}
        \item Create a source file inside the src folder (src/)
            \begin{itemize}
                \item name it using the class name with a .cc extension.
                \item include the header file (\#include).
                \item define the class methods.
            \end{itemize}
    \end{enumerate}
\end{frame}

\begin{frame}
    \frametitle{Typical header file}

    \begin{center}
        \includegraphics[scale=0.20]{resources/typical_header}
    \end{center}
\end{frame}

\begin{frame}
    \frametitle{Typical source file}

    \begin{center}
        \includegraphics[scale=0.20]{resources/typical_source}
    \end{center}
\end{frame}

\begin{frame}
    \frametitle{Classes}

    \begin{center}
        \includegraphics[scale=0.20]{resources/classes}
    \end{center}

    * Gray are optional.
\end{frame}

\begin{frame}
    \frametitle{Primary generator action}

    \begin{center}
        \includegraphics[scale=0.35]{resources/primary_generator_action}
    \end{center}

    Defines the source of simulated particles.

    \begin{itemize}
        \item particle type.
        \item kinematic properties.
        \item additional information.
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Physics list}

    \begin{center}
        \includegraphics[scale=0.275]{resources/physics_list}
    \end{center}

    \begin{itemize}
        \item Define all necessary particles.
        \item Define all necessary processes and assign them to proper particles.
        \item Define particles production threshold.
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Detector construction}

    \begin{center}
        \includegraphics[scale=0.250]{resources/detector_construction}
    \end{center}

    \begin{itemize}
        \item Define the geometry of your model.
            \begin{itemize}
                \item All materials
                \item All volumes \& placements
            \end{itemize}
        \item Optionally define fields.
        \item Optionally define sensitive detectors.
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{User interaction}

    Communicate with your application at three levels:

    \begin{itemize}
        \item Hard-Coded: application with no interaction.
        \item Batch mode: controlled by a macro.
        \item Interactive mode: with real-time user response.
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{User interaction}

    \begin{center}
        \includegraphics[scale=0.250]{resources/user_action_initialization}
    \end{center}

    Optional actions as hooks:

    \begin{itemize}
        \item G4UserRunAction.
        \item G4UserEventAction.
        \item G4UserStackingAction.
        \item G4UserTrackingAction.
        \item G4UserSteppingAction.
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{Visualization}

    \begin{itemize}
        \item View and debug your geometry.
        \item View and study the tracks.
        \item Product publication-ready graphics.
        \item Export events and geometry to text files.
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{main()}

    Geant4 does not provide a main function for you. Remember this is just a toolkit. All C++ programs need one, hence we define one.

    \begin{itemize}
        \item Create a source .cc file in the root directory of the application.
        \item Define a main function.
        \item Inside the main function:
            \begin{itemize}
                \item Initialize the run manager.
                \item Initialize all your initialization classes.
                \item Initialize user interface and/or visualization.
            \end{itemize}
    \end{itemize}
\end{frame}

\begin{frame}
    \frametitle{main()}

    \begin{center}
        \includegraphics[scale=0.225]{resources/main_method}
    \end{center}
\end{frame}
